CompactBars = LibStub("AceAddon-3.0"):NewAddon("CompactBars-0.1", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):NewLocale("CompactBars", "enUS", true)

local sb = LibStub:GetLibrary("SBar-0.1")
local cps = 0
CompactBars.sb = sb
local newList, del, deepDel, deepCopy = sb:GetRecyclingFunctions()
CompactBars.colorcache = {}
local expT = newList()



local function hideFixedText(uid, pos)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.pos and bar.pos == pos then return end
    end
    sb:SetFixedText(nil, pos)
end
local function hideBar(info)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid and bar.data.typ == info.typ then
            local pos = bar.pos
            bar.start = nil
        end
    end
end
local function iterateFixedText()
    local bars = sb:GetBars()
    if not bars or #bars == 0 then return end
    
    for i = 1, 10 do
        -- find a bar for that position
        for _, bar in pairs(bars) do
            if bar.pos and bar.pos == i then
                if bar.data and bar.data.typ and (bar.data.typ == "Dots" or bar.data.typ == "CCs" or bar.data.typ == "Debuffs") then
                    if not CompactBars.db.profile.owndots then
                        if not CompactBars.db.profile.ehidetext then
                                sb:SetFixedText(bar.data.name, i)
                                break
                        end
                    end
                end
            end
        end
    end
end
local function findFirstEmptyBar(init)
    local bars = sb:GetBars()
    if not bars then return init end
    for i = init, 10 do
        local flag = true
        for _, bar in pairs(bars) do 
            if bar.pos and bar.pos == i then
                flag = false
            end
        end
        if flag then return i end
    end
end
function CompactBars:updateBarPos()
    positions = {strsplit(",", CompactBars.db.profile.barorder)}
    for k,v in pairs(positions) do positions[k] = strtrim(v) end
    
    bars = sb:GetBars()
    if not bars or #bars == 0 then return end
    for k,v in pairs(bars) do 
        v.order = nil
        if v.pos then sb:SetFixedText(nil, v.pos) end
    end
    local curpos = 0
    local firstdebuff, firstshortbuff, firstcooldown, firstbossmod = true, true, true, true
    for i = 1, 4 do
        for _, bar in pairs(bars) do
            if positions[i] == "Debuffs" and bar.data and (bar.data.typ == "Debuffs" or bar.data.typ == "CCs" or bar.data.typ == "Dots") then
                local ftext
                if firstdebuff then
                    --ftext = sb:GetFixedText(bar.pos)
                    --sb:SetFixedText(nil, bar.pos)
                    --sb:SetFixedText(ftext, curpos)
                    bar.pos = curpos
                    bar.order = true
                    curpos = curpos + 1
                    firstdebuff = nil
                else
                    -- try to find a bar that fits
                    for _, b in pairs(bars) do
                        if b.order and not bar.order and b.data and bar.data.dguid == b.data.dguid and (bar.data.typ == "Debuffs" or bar.data.typ == "CCs" or bar.data.typ == "Dots") then
                            bar.pos = b.pos
                            bar.order = true
                            break
                        end
                    end
                    if not bar.order then
                        --ftext = sb:GetFixedText(bar.pos)
                        --sb:SetFixedText(nil, bar.pos)
                        --sb:SetFixedText(ftext, curpos)
                        bar.pos = curpos
                        bar.order = true
                        curpos = curpos + 1
                    end
                end
            elseif positions[i] == "Shortbuffs" and bar.data and (bar.data.typ == "Shortbuffs") then
                if firstshortbuff then
                    bar.pos = curpos
                    bar.order = true
                    curpos = curpos + 1
                    firstshortbuff = nil
                else
                    for _, b in pairs(bars) do
                        if b.order and not bar.order and b.data and b.data.typ == bar.data.typ then
                            bar.pos = b.pos
                            bar.order = true
                            break
                        end
                    end
                end
            elseif positions[i] == "Bossmods" and bar.data and (bar.data.typ == "Bossmods") then
                if firstbossmod then
                    bar.pos = curpos
                    bar.order = true
                    curpos = curpos + 1
                    firstbossmod = nil
                else
                    for _, b in pairs(bars) do
                        if b.order and not bar.order and b.data and b.data.typ == bar.data.typ then
                            bar.pos = b.pos
                            bar.order = true
                            break
                        end
                    end
                end
                
            elseif positions[i] == "Cooldowns" and bar.data and (bar.data.typ == "Cooldowns" or bar.data.typ == "ItemCooldowns" or bar.data.typ == "InternalCooldowns") then
                if firstcooldown then
                    bar.pos = curpos
                    bar.order = true
                    curpos = curpos + 1
                    firstcooldown = nil
                else
                    for _, b in pairs(bars) do
                        if b.order and not bar.order and b.data and (b.data.typ == "Cooldowns" or  b.data.typ == "ItemCooldowns" or b.data.typ == "InternalCooldowns") then
                            bar.pos = b.pos
                            bar.order = true
                            break
                        end
                    end
                end
            end
        end
    end
    iterateFixedText()
end
local function getBarPos(uid, typ)
    local positions = {strsplit(",", CompactBars.db.profile.barorder)}
    local pos = {}
    for k, v in pairs(positions) do
        pos[strtrim(v)] = k - 1
    end
    local debuffpos = pos["Debuffs"]
    local init = 0
    local findflag
    if CompactBars.db.profile.eshortbuffs then
        if pos["Shortbuffs"] < debuffpos then
            if typ == "Shortbuffs" then 
                return 0--init 
            end
            init = init + 1
        else
            if typ == "Shortbuffs" then 
                findflag = true
            end
        end
    end
    if CompactBars.db.profile.ecooldowns then
        if pos["Cooldowns"] < debuffpos then
            if typ == "Cooldowns" then 
                return 0--init 
            end
        else
            if typ == "Cooldowns" then 
                findflag = true
            end
        end
    end
    if CompactBars.db.profile.einternalcooldowns then
        if pos["Cooldowns"] < debuffpos then
            if typ == "InternalCooldowns" then 
                return 0--init 
            end
        else
            if typ == "InternalCooldowns" then 
                findflag = true
            end
        end
    end
    if CompactBars.db.profile.ecooldowns or CompactBars.db.profile.einternalcooldowns or CompactBars.db.profile.eitemcooldowns then
        if pos["Cooldowns"] < debuffpos then
            init = init + 1
        end
    end
    
    if CompactBars.db.profile.ebossmods then
        if pos["Bossmods"] < debuffpos then
            if typ == "Bossmods" then 
                return 0--init 
            end
            init = init + 1
        else
            if typ == "Bossmods" then 
                findflag = true
            end
        end
    end
    local bars = sb:GetBars()
    if bars and #bars == 0 then bars = nil end
    if not bars and not findflag then return debuffpos end
    
    if not bars then return init end
    if findflag then
        for _, bar in pairs(bars) do
            if bar.data then
                if bar.data.dguid == uid and bar.data.typ == typ then
                    return 0--bar.pos
                end
            end
        end
    else
        for _, bar in pairs(bars) do
            if bar.data then
                if bar.data.dguid == uid then
                    return 0--bar.pos
                end
            end
        end
    end
    if findflag then
        return findFirstEmptyBar(init)
    end
    return 0--findFirstEmptyBar(debuffpos)
end
function CompactBars:GetBarPos(uid, typ)
    return getBarPos(uid, typ)
end
local function isBarActive(info)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid and bar.data.typ == info.typ then
            return true
        end
    end
    return false
end
local function setBarDur(info, dur)
    local bars = sb:GetBars()
    if bars then
        for _, bar in pairs(bars) do
            if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid then
                bar.dur = dur
                bar.start = 0
                return
            end
        end
    end
    local dur, appl, color, colorzero = CompactBars:GetSpellInfo(info.typ, info.spellid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    if not dur then return end
    if info and info.typ and not isBarActive(info) then
        sb:CreateBar(info, dur, 0, nil, select(3, GetSpellInfo(info.spellid)), getBarPos(info.dguid, info.typ), color, colorzero, CompactBars.db.profile.bartexture)
        CompactBars:updateBarPos()
    end
    CompactBars.sb:UpdateFrameLevel()
end

local function setBarColor(info, color, colorzero)
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.data and bar.data.dguid == info.dguid and bar.data.spellid == info.spellid then
            bar.color = deepCopy(color)
            bar.colorzero = deepCopy(colorzero)
            bar.tex:SetVertexColor(color.r, color.g, color.b, color.a)
            bar.texg:SetVertexColor(colorzero.r, colorzero.g, colorzero.b, colorzero.a)
        end
    end
end

function CompactBars:StartItemCooldown(itemid, duration)
    if not CompactBars:GetSpellInfo("ItemCooldowns", itemid) then return end
    local infocd = newList()
    infocd.typ = "ItemCooldowns"
    infocd.spellid = itemid
    infocd.dguid = UnitGUID("player")
    
    local dur, appl, color, colorzero = CompactBars:GetSpellInfo(infocd.typ, itemid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    
    if not isBarActive(infocd) and getBarPos(infocd.dguid, infocd.typ) then
        if dur == 0 then
            sb:CreateBar(deepCopy(infocd), duration, 0, nil, select(3, GetSpellInfo(itemid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, CompactBars.db.profile.bartexture)
            self:updateBarPos()
        else 
            sb:CreateBar(deepCopy(infocd), dur, 0, nil, select(3, GetSpellInfo(itemid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, CompactBars.db.profile.bartexture)
            self:updateBarPos()
        end
    end
    del(infocd)
end
local function schoolColor(spellschool)
    if spellschool == 1 then
        return deepCopy(CompactBars.db.profile.barcolor.physical), deepCopy(CompactBars.db.profile.barcolorzero.physical)
    elseif spellschool == 2 then
        return deepCopy(CompactBars.db.profile.barcolor.holy), deepCopy(CompactBars.db.profile.barcolorzero.holy)
    elseif spellschool == 4 then
        return deepCopy(CompactBars.db.profile.barcolor.fire), deepCopy(CompactBars.db.profile.barcolorzero.fire)
    elseif spellschool == 8 then
        return deepCopy(CompactBars.db.profile.barcolor.nature), deepCopy(CompactBars.db.profile.barcolorzero.nature)
    elseif spellschool == 16 then
        return deepCopy(CompactBars.db.profile.barcolor.frost), deepCopy(CompactBars.db.profile.barcolorzero.frost)
    elseif spellschool == 32 then
        return deepCopy(CompactBars.db.profile.barcolor.shadow), deepCopy(CompactBars.db.profile.barcolorzero.shadow)
    elseif spellschool == 64 then
        return deepCopy(CompactBars.db.profile.barcolor.arcane), deepCopy(CompactBars.db.profile.barcolorzero.arcane)
    end
end
function CompactBars:getTyp(spellid)
    if CompactBars:GetSpellInfo("Dots", spellid) then
        return "Dots"
    elseif CompactBars:GetSpellInfo("Debuffs", spellid) then
       return "Debuffs"
    elseif CompactBars:GetSpellInfo("CCs", spellid) then
        return "CCs"
    elseif CompactBars:GetSpellInfo("Shortbuffs",spellid) then
        return "Shortbuffs"
    elseif CompactBars:GetSpellInfo("InternalCooldowns", spellid) then
        return "InternalCooldowns"
    elseif CompactBars:GetSpellInfo("SharedDebuffs", spellid) then
        return "SharedDebuffs"
    else return false end
end
local function createSpellInfo(dguid, spellid, typ, name)
    if not typ then return false end
    local infos = newList()
    infos.dguid = dguid
    infos.spellid = spellid
    infos.typ = typ
    infos.name = name
    return infos
end


function CompactBars:SpellCooldownStart(spellid, duration)
    if not CompactBars:GetSpellInfo("Cooldowns", spellid) then return end
    local infocd = newList()
    infocd.typ = "Cooldowns"
    infocd.spellid = spellid
    infocd.dguid = UnitGUID("player")
    
    local dur, appl, color, colorzero = CompactBars:GetSpellInfo(infocd.typ, spellid)
    if not color then color = {r = 1, g = 1, b = 1, a = 1} end
    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
    
    
    if not isBarActive(infocd) and getBarPos(infocd.dguid, infocd.typ) then
        if dur == 0 then
            sb:CreateBar(deepCopy(infocd), duration, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, CompactBars.db.profile.bartexture)
            self:updateBarPos()
        else 
            sb:CreateBar(deepCopy(infocd), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(infocd.dguid, infocd.typ), color, colorzero, CompactBars.db.profile.bartexture)
            self:updateBarPos()
        end
    end
    del(infocd)
end
function CompactBars:SpellCooldownEnd(spellid)
    if not CompactBars:GetSpellInfo("Cooldowns", spellid) then return end
    local info = newList()
    info.typ = "Cooldowns"
    info.spellid = spellid
    info.dguid = UnitGUID("player")
    
    hideBar(info)
end
function CompactBars:PLAYER_LOGIN()
    CompactBars.sb:CreateScale(CompactBars.db.profile.width, CompactBars.db.profile.maxtime, CompactBars.db.profile.steps,
                    CompactBars.db.profile.maxneg, CompactBars.db.profile.position,CompactBars.db.profile.horizontal,
                    CompactBars.db.profile.loflag, CompactBars.db.profile.scaletexture, CompactBars.db.profile.locked,
                    CompactBars.db.profile.scale, CompactBars.db.profile.height, CompactBars.db.profile.fonts,
                    CompactBars.db.profile.scaletext, CompactBars.db.profile.amaxtimes, CompactBars.db.profile.ehidescale,
                    CompactBars.db.profile.eiconpos, CompactBars.db.profile.nevershowscale)
    if CompactBars.db.profile.markers then
        for k, v in pairs({strsplit(",", CompactBars.db.profile.markers)}) do
            CompactBars.sb:CreateMarker(tonumber(strtrim(v)))
        end
    end
    self:SpellUpdate()
end
function CompactBars:OnInitialize()
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
    self:RegisterEvent("UNIT_COMBO_POINTS", "SaveCombo")
    self:RegisterEvent("PLAYER_LOGIN")
end
local function removeDots()
    local init = 0
    if CompactBars.db.profile.eshortbuffs then
        init = init + 1
    end
    if CompactBars.db.profile.ecooldowns then
        init = init + 1
    end
    local bars = sb:GetBars()
    if not bars then return end
    for _, bar in pairs(bars) do
        if bar.pos and bar.pos >= init then
            bar.frame:Hide()
            bar.frame = nil
            local pos = bar.pos
            bar.pos = nil
            bar.data = nil
            deepDel(bar)
            bar = nil
        end
    end
end
local function addDots()
    
    for i = 1, 40 do
        if UnitDebuff("target", i) then
            local name, rank, _, application, _, _, expTime, ismine = UnitDebuff("target", i)
            ismine = ismine == "player"
            if name then
                if appl == 0 then appl = 1 end
                local link = GetSpellLink(name, rank)
                if link then
                    local spellid = string.match(link, "Hspell:(%d+)")
                    local info = createSpellInfo(UnitGUID("target"), spellid, CompactBars:getTyp(spellid), UnitName("target"))
                    if info and (info.typ == "SharedDebuffs" or ismine) then 
                        if info then
                            spellid = tonumber(spellid)
                            local dur, appl, color, colorzero = CompactBars:GetSpellInfo("Shortbuffs", spellid)
                            dur = expTime - GetTime()
                            
                            if not color then
                                color = deepCopy(CompactBars.colorcache[spellid])
                                
                            end
                            if not color then
                                color = {r = 1, g = 1, b = 1, a = 1}
                            end
                            if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                            if not appl or appl == 0 then appl = 1 end
                            if not application or application == 0 then application = 1 end
                            color.a = (application / appl) * (color.a or 1)

                            if (not isBarActive(info)) and getBarPos(info.dguid, info.typ) then
                                sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, CompactBars.db.profile.bartexture)
                                CompactBars:updateBarPos()
                            end
                        end
                    end
                end
            end
        end
    end
end
function CompactBars:TargetChanged(msg, changer)
    if changer == "player" then
        removeDots()
        addDots()
    end
end
local function debuffCheck(cname, id)
    for i = 1, 40 do
        local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable  =  UnitDebuff("target", i)
        isMine = isMine == "player"
        if isMine and cname == name then
            return name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable
        end
        if CompactBars:getTyp(id) == "SharedDebuffs" and cname == name then
            return name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable
        end
    end
end
function CompactBars:CombatLogEvent(msg, timestamp, event, sguid, sname, sflags, dguid, dname, dflags, spellid, spellname, spellschool, auraType, application )
    -- buffs
    local info, dur, appl, color, colorzero
    if auraType == "BUFF" then
        if event == "SPELL_AURA_APPLIED" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid), dname)
            if not info then return end
            
            dur, appl, color, colorzero = CompactBars:GetSpellInfo("Shortbuffs", spellid)
            
            if dur then
                if tonumber(dur) then
                    if not color then
                        color, colorzero = schoolColor(spellschool)
                    end
                    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                    if appl then
                        color.a = (1/appl) * (color.a or 1)
                    end
                    
                    if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                        sb:CreateBar(deepCopy(info), tonumber(dur), 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
                        CompactBars:updateBarPos()
                    end
                end
            end
            if info then
                deepDel(info)
            end
            info = nil
            -- internal cooldowns
            info = createSpellInfo(UnitGUID("player"), spellid, "InternalCooldowns", dname)
            dur, appl, color, colorzero = CompactBars:GetSpellInfo("InternalCooldowns", spellid)
            if dur then
                if tonumber(dur) then
                    if not color then
                        color, colorzero = schoolColor(spellschool)
                    end
                    if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                    if appl then
                        color.a = (1/appl) * (color.a or 1)
                    end
                    if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                        sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
                        CompactBars:updateBarPos()
                    end
                end
            end
                -- ic end
        elseif event == "SPELL_AURA_REMOVED" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid), dname)
            if info then
                if not (info.typ == "InternalCooldowns") then
                    hideBar(info)
                end
            end
        elseif event == "SPELL_AURA_APPLIED_DOSE" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid), dname)
            if info then
                dur, appl, color, colorzero = self:GetSpellInfo("Shortbuffs", spellid)
                if not color then
                    color, colorzero = schoolColor(spellschool)
                end
                color.a = (application / appl) * (color.a or 1)
                if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                setBarDur(deepCopy(info), self:GetSpellInfo("Shortbuffs", spellid))
                setBarColor(info, color, colorzero)
            end
        elseif event == "SPELL_AURA_REFRESH" and (dguid == UnitGUID("player") or dguid == UnitGUID("pet")) then
            info = createSpellInfo(UnitGUID("player"), spellid, self:getTyp(spellid), dname)
            if info then
                dur, appl, color, colorzero = self:GetSpellInfo("Shortbuffs", spellid)
                setBarDur(deepCopy(info), dur)
            end
        end
    elseif auraType == "DEBUFF" then
    -- debuffs
        if event == "SPELL_AURA_APPLIED" then
            if CompactBars:GetSpellInfo("SharedDebuffs", spellid) or (sguid == UnitGUID("player")) then
                if (self.db.profile.owndots and dguid == UnitGUID("target")) or (not self.db.profile.owndots) then
                    info = createSpellInfo(dguid, spellid, self:getTyp(spellid), dname)
                    if info then
                        expT[spellid..dguid] = select(7, debuffCheck(spellname, spellid))
                        dur, appl, color, colorzero = self:GetSpellInfo(info.typ, spellid)
                        if not color then
                            color, colorzero = schoolColor(spellschool)
                        end
                        
                        if appl then
                            color.a = (1/appl) * (color.a or 1)
                        end
                        
                        if not colorzero then colorzero = deepCopy(color); colorzero.a = 0.1 end
                        if not isBarActive(info) and getBarPos(info.dguid, info.typ) then
                            local bar = sb:CreateBar(deepCopy(info), dur, 0, nil, select(3, GetSpellInfo(spellid)), getBarPos(info.dguid, info.typ), color, colorzero, self.db.profile.bartexture)
                            CompactBars:updateBarPos()
                            --if not self.db.profile.owndots then
                            --    if not self.db.profile.ehidetext then
                                    --sb:SetFixedText(dname, getBarPos(info.dguid, info.typ))
                            --    end
                            --end
                        if CompactBars.db.profile.spells[info.spellid..info.typ].eticks then
                            if CompactBars.db.profile.spells[info.spellid..info.typ].ticktimer and type(CompactBars.db.profile.spells[info.spellid..info.typ].ticktimer) == "number" then
                                CompactBars.sb:createTicker(bar, CompactBars.db.profile.spells[info.spellid..info.typ].ticktimer)
                                
                            else
                                CompactBars.db.profile.spells[info.spellid..info.typ].ticktimer = tostring(timestamp)
                            end
                        end
                            CompactBars.colorcache[spellid] = deepCopy(color)
                        end
                    end
                end
            end
        -- this event does not provide sguid! returns 0
        elseif event == "SPELL_AURA_REFRESH" and (CompactBars:GetSpellInfo("SharedDebuffs", spellid) or (sguid == UnitGUID("player"))) then
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid), dname)
            if info then
                setBarDur(deepCopy(info), self:GetSpellInfo(info.typ, spellid))
            end
        -- this event does not provide sguid! returns 0
        elseif event == "SPELL_AURA_APPLIED_DOSE" and (CompactBars:GetSpellInfo("SharedDebuffs", spellid) or (sguid == UnitGUID("player"))) then
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid), dname)
            if info then
                dur, appl, color, colorzero = self:GetSpellInfo(info.typ, spellid)
                if not color then
                    color, colorzero = schoolColor(spellschool)
                end
                if appl then
                    color.a = (application/appl) * (color.a or 1)
                end
                setBarDur(deepCopy(info), self:GetSpellInfo(info.typ, spellid))
                setBarColor(info, color, colorzero)
            end
        elseif event == "SPELL_AURA_REMOVED" and (sguid == UnitGUID("player") or CompactBars:getTyp(spellid) == "SharedDebuffs") then
            info = createSpellInfo(dguid, spellid, self:getTyp(spellid), dname)
            if info then
                expT[spellid..dguid] = nil
                hideBar(info)
            end
        end
    elseif event == "SPELL_PERIODIC_DAMAGE" and (sguid == UnitGUID("player")) then
        if CompactBars.db.profile.spells[spellid.."Dots"] then
            if type(CompactBars.db.profile.spells[spellid.."Dots"].ticktimer) == "string" then
                CompactBars.db.profile.spells[spellid.."Dots"].ticktimer = tostring(timestamp - tonumber(CompactBars.db.profile.spells[spellid.."Dots"].ticktimer))
                local bcomma, acomma = string.match(tostring(CompactBars.db.profile.spells[spellid.."Dots"].ticktimer), "(%d)\.(%d)")
                if acomma then
                    if tonumber(acomma) <= 4 then
                        CompactBars.db.profile.spells[spellid.."Dots"].ticktimer = tonumber(bcomma)
                    else
                        CompactBars.db.profile.spells[spellid.."Dots"].ticktimer = tonumber(bcomma) + 1
                    end
                end
            else
                -- reset the timer to the maximum
                local bars = CompactBars.sb:GetBars()
                if bars and #bars ~= 0 then
                    for _, bar in pairs(bars) do
                        if bar and bar.data and bar.data.dguid == dguid and bar.data.spellid == spellid then
                            if bar.ticker then
                                bar.ticker.time = bar.ticker.maxtime
                                break
                            end
                        end
                    end
                end
            end
        end
    end
    if info then
        deepDel(info)
    end
end
function CompactBars:SaveCombo(msg, unit)
    if GetComboPoints("player") ~= 0 then
        cps = GetComboPoints("player")
    end
end
function CompactBars:GetComboPoints()
    return cps
end
function CompactBars:checkGlyph(name)
	for i = 1, 6 do
		local glyph = select(3, GetGlyphSocketInfo(i))
		if glyph == name then
			return true
		else
			return false
		end
	end
end
function CompactBars:scanItem(id)
	for i = 0, 18 do
		if string.find(GetInventoryItemLink("player", i), id) then return true end
	end
	return false
end