local sp = CompactBars:GetModule("spells")
local rogue = {
    Dots = {
            -- Garrote
            [8631] = 703,
            [8632] = 703,
            [8633] = 703,
            [11289] = 703,
            [11290] = 703,
            [26839] = 703,
            [26884] = 703,
            [48676] = 703,
            [48675] = 703,
            [703] = [[if CompactBars:checkGlyph(56812) then return 15 else return 18 end]],
            -- Rupture
            [8639] = 1943,
            [8640] = 1943,
            [11273] = 1943,
            [11274] = 1943,
            [11275] = 1943,
            [26867] = 1943,
            [48671] = 1943,
            [48672] = 1943,
            [1943] = [[return CompactBars.sp:GMTD(1943)]],
            -- Deadly Poison
            [11353] = 2818,
            [2819] = 2818,
            [11354] = 2818,
            [25349] = 2818,
            [26968] = 2818,
            [27187] = 2818,
            [57969] = 2818,
            [57970] = 2818,
            [2818] = [[return 12, 5]],
        },	
        Debuffs = {-- Wound Poison
            [13222] = 13218,
            [13223] = 13218,
            [13224] = 13218,
            [27189] = 13218,
            [57974] = 13218,
            [57975] = 13218,
            [13218] = [[return 15]],
            -- Crippling Poison
            [3409] = [[return 12]],
            -- Mind-numbing Poison
            [5760] = [[return 10]],

			-- dismantle
			[51722] = [[return CompactBars.sp:GMTD(51722)]],
			-- deadly throw
			[26679] = [[return CompactBars.sp:GMTD(26679)]],
			[48673] = 26679,
			[48674] = 26679,
			-- riposte
			[14251] = [[return CompactBars.sp:GMTD(14251)]],
            
        },
        SharedDebuffs = {
            			-- expose armor
			-- 3.1
			[8647] = [[return CompactBars.sp:GTD(8647)]], 
        },
        Shortbuffs = {
            -- Slice and Dice
            [6774] = 5171,
            [5171] = [[return CompactBars.sp:GPB(5171), nil, {r = 222/255, g = 184/255, b = 135/255, a = 1}]],
            -- Blade flurry
            [13877] = [[return CompactBars.sp:GPB(13877), nil, {r = 219/255,g = 219/255, b = 112/255, a = 1}]],
            -- Hunger for Blood
            [51662] = [[return CompactBars.sp:GPB(51662), 3, {r = 142/255,g = 35/255, b = 35/255, a = 1}]],
            -- Adrenaline Rush
            [13750] = [[return CompactBars.sp:GPB(13750), 3, {r = 1,g = 1, b = 1, a = 1}]],
            -- evsion
            [5277] = [[return CompactBars.sp:GPB(5277)]],
            [26669] = [[return CompactBars.sp:GPB(26669)]],
            -- sprint
            [2983] = [[return CompactBars.sp:GPB(2983)]],
            [8696] = [[return CompactBars.sp:GPB(8696)]],
            [11305] = [[return CompactBars.sp:GPB(11305)]],
            -- feint
			[48659] = [[return CompactBars.sp:GPB(48659)]],
			-- vanish
			[1856] = [[return CompactBars.sp:GPB(1856)]],
			[1857] = 1857,
			[26889] = 1857,
			-- cloak of shadows
			[31224] = [[return CompactBars.sp:GPB(31224)]],
			-- envenom
			[32684] = [[return CompactBars.sp:GPB(32684), nil, {r = 0, g = 1, b = 0, a = 1}]],
			[32645] = 32684,
			[57992] = 32684,
			[57993] = 32684,
			-- shadow dance
			[51713] = [[return CompactBars.sp:GPB(51713)]],
            -- shadowstep
            [36554] = [[return CompactBars.sp:GPB(36554)]],
            
        },
        Cooldowns = {
			-- Blade flurry
            [13877] = 5277,
			-- Adrenaline Rush
            [13750] = 5277,
            -- kidney shot
            [8643] = 5277,
            [408] = 5277,
            -- shadowstep
            [36554] = 5277,
			-- shadow dance
			[51713] = 5277,
			-- cold blood
			[14177] = 5277,
			-- killing spree
			[51690] = 5277,
			-- premeditation
			[14183] = 5277,
			-- preperation
			[14185] = 5277,
			-- riposte
			[14251] = 5277,
			-- cloak of shadows
			[31224] = 5277,
			-- blind
			[2094] = 5277,
			-- vanish
			[1856] = 5277,
			[1857] = 5277,
			[26889] = 5277,
			-- stealth
			[1785] = 5277,
			[1784] = 5277,
			[1786] = 5277,
			[1787] = 5277,
			-- distract
			[1725] = 5277,
			-- dismantle
			[51722] = 5277,
			-- feint
			[1966] = 5277,
			[6768] = 5277,
			[8637] = 5277,
			[11303] = 5277,
			[25302] = 5277,
			[27448] = 5277,
			[48658] = 5277,
			[48659] = 5277,
			-- kick
			[1766] = 5277,
            -- evsion
            [5277] = [[return 0]],
            [26669] = 5277,
            -- sprint
            [2983] = 5277,
            [8696] = 5277,
            [11305] = 5277,
			-- Tricks of the Trade
            [57934] = [[return 0, 1, {r = 1, g = 0, b = 0, a = 1}]],
        },
		CCs = {
			-- cheap shot
			[1833] = [[return CompactBars.sp:GMTD(1833)]],
			-- sap
			[6770] = [[return CompactBars.sp:GMTD(6770)]],
			[2070] = 6770,
			[11297] = 6770,
			[51724] = 6770,
			-- blind
			[2094] = [[return 10]],
            -- kidney shot
            [8643] = [[return CompactBars.sp:GMTD(8643)]],
            [408] = [[return CompactBars.sp:GMTD(408)]],
		},
}
if select(4, GetBuildInfo()) > 30000 then
	rogue.Shortbuffs[63848] = [[return CompactBars.sp:GPB(63848), 1, {r = 142/255,g = 35/255, b = 35/255, a = 1}]]
end
sp:insertSpells(rogue, "ROGUE")
